#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
IJOC-Scenario grouping 
example codes for generating instance data
"""

import pandas as pd
import numpy as np


# problem (i)
d=20
K=200
a_l=0.8
a_u=1.5
r=1.1
df=pd.DataFrame(np.random.uniform(a_l, a_u, (K,d))) # add values to store
c=np.random.randint(1,100,size=d)
df.loc[K]=c
df.index = [''.join(['ak--Sce',str(i)]) for i in range(1,K+1)]+['c']
df.columns = [''.join(['Asset',str(i)]) for i in range(1,d+1)]

excelname= ''.join(['data_problem_(i).xls'])
df.to_excel(excelname)  

# problem (ii)  mk-20-10 K=100, source file: OR-library, mknap1
folderposition = 'problem_(ii)/'
n=20
m=10
K=100
# read deterministic data
b=[ 550, 700, 130, 240, 280, 310, 110, 205, 260, 275]
p =  [ 100 ,220 ,90, 400, 300, 400, 205, 120, 160, 580, 400, 140, 100, 1300, 650, 320, 480, 80, 60, 2550 ]
deter = np.array(pd.read_csv('problem_(ii)/deter-mk-20-10.txt', sep=' ' ,header=None) )

for i in range(K):
    mat = np.zeros((10,20))
    for j in range(n):
        cov=np.diag(0.1*deter[:,j])
        mat[:,j] = np.random.multivariate_normal(deter[:,j], cov)
    mat = np.maximum(mat, 0)
    df=pd.DataFrame(mat)
    df.index = [''.join(['dim',str(i)]) for i in range(1,m+1)]
    df.columns = [''.join(['item',str(i)]) for i in range(1,n+1)]
    excelname= ''.join([folderposition,'Sce',str(i+1),'.xls'])
    df.to_excel(excelname) 